"Filed out from Dolphin Smalltalk 99 release 3.0"!

Describable subclass: #Container
	instanceVariableNames: 'contents inventoryable'
	classVariableNames: ''
	poolDictionaries: ''!

Container class instanceVariableNames: ''!

Container comment: 'Something which can contain other things.'!

Container guid: (GUID fromString: '{B1FE94A6-54A3-11D3-8268-00001D19F5C2}')!

!Container categoriesForClass!Adventure! !

!Container methodsFor!

add: anObject
	"Add a new object to the collection of objects in this container"

	self remove: anObject.	"Make sure it's not already in this container"
	self contents add: anObject.
	^Response text: 'OK'!

basicLighted
	^false!

contains: anObject
	^self contents includes: anObject!

containsLightSource
	^self basicLighted | (self contents inject: false into: [ :tot :each | tot | each containsLightSource ])!

contents
	"Answer the value of the receiver's instance variable contents.
	This method was automatically generated, but may be modified."

	^contents!

contentsDescription
	^''!

contentsLike: aString
	| pattern |

	pattern := '*', aString, '*'.
	^self contents select: [ :each |
		(pattern match: each shortDescription) | (pattern match: each longDescription) ]!

initialize
	super initialize.
	contents := OrderedCollection new.
	self inventoryable: true!

inventory
	"Answer a string describing the contents of this container"

	^self subclassResponsibility!

inventory2ndPersonWithPrefix: aPrefixString suffix: aSuffixString
	"Private - answer this Container's inventory using the given prefix and suffix"
	^self contents inject: '' into: [ :string :each |
		each inventoryable
			ifTrue: [
				(each basicLongDescription isNil
					ifTrue: [
						string, (string size > 0 ifTrue: [ String lineDelimiter ] ifFalse: ['']),
						aPrefixString, ' ', each inventoryDescription2ndPerson,
						(aSuffixString size > 0 ifTrue: [ ' ', aSuffixString ] ifFalse: [ '' ]) ]
					ifFalse: [ string, each basicDescription ]),
				(each contents size > 0
					ifTrue: [ '.  The ', each shortNounPhrase, ' contains:',
											String lineDelimiter,
											(each inventoryWithPrefix: '   ' suffix: '') ]
					ifFalse: [ '' ]) ]
			ifFalse: [ string ] ]!

inventory3dPersonWithPrefix: aPrefixString suffix: aSuffixString
	"Private - answer this Container's inventory using the given prefix and suffix"

	^self contents inject: '' into: [ :string :each |
		each inventoryable
			ifTrue: [
				(each basicLongDescription isNil
					ifTrue: [
						string, (string size > 0 ifTrue: [ String lineDelimiter ] ifFalse: ['']),
						aPrefixString, ' ', each inventoryDescription3dPerson,
						(aSuffixString size > 0 ifTrue: [ ' ', aSuffixString ] ifFalse: [ '' ]),
						(each treasure ifTrue: [ '!!' ] ifFalse: [ '' ]) ]
					ifFalse: [ string, each basicDescription ]),
				(each contents size > 0
					ifTrue: [ '.  The ', each shortNounPhrase, ' contains:',
											String lineDelimiter,
											(each inventoryWithPrefix: '   ' suffix: '') ]
					ifFalse: [ '' ]) ]
			ifFalse: [ string ] ]!

inventoryable
	"Answer the value of the receiver's instance variable inventoryable.
	This method was automatically generated, but may be modified."

	^inventoryable!

inventoryable: anObject
	"Set the value of the receiver's instance variable inventoryable to anObject.
	This method was automatically generated, but may be modified."

	inventoryable := anObject!

inventoryStringWithPrefix: aPrefixString suffix: aSuffixString
	| description contentsDescription |

	self inventoryable
		ifTrue: [
			self basicLongDescription size > 0
				ifTrue: [ description := self basicDescription ]
				ifFalse: [ description := aPrefixString, ' ', self description,
					      ((aSuffixString size > 0) ifTrue: [ ' ' ] ifFalse: [ '' ]), aSuffixString, '.' ].

			self contents size > 0
				ifTrue: [ contentsDescription := 'The ', self shortNounPhrase, ' contains:',
								String lineDelimiter,
								(self inventoryWithPrefix: '   ' suffix: '') ]
				ifFalse: [ contentsDescription := '' ] ]
		ifFalse: [ description := ''.  contentsDescription := ''. ].

	^description, contentsDescription!

inventoryWithPrefix: aPrefixString suffix: aSuffixString
	"Private - answer this Container's inventory using the given prefix and suffix"
	^self contents inject: '' into: [ :string :each |
		string, (string size > 0 ifTrue: [ String lineDelimiter ] ifFalse: ['']),
			(each inventoryStringWithPrefix: aPrefixString suffix: aSuffixString) ]!

remove: anObject
	^self contents remove: anObject ifAbsent: [ ]! !

!Container categoriesFor: #add:!*-unclassified!public! !
!Container categoriesFor: #basicLighted!*-unclassified!public! !
!Container categoriesFor: #contains:!*-unclassified!public! !
!Container categoriesFor: #containsLightSource!*-unclassified!public! !
!Container categoriesFor: #contents!accessing!public! !
!Container categoriesFor: #contentsDescription!*-unclassified!public! !
!Container categoriesFor: #contentsLike:!*-unclassified!public! !
!Container categoriesFor: #initialize!*-unclassified!public! !
!Container categoriesFor: #inventory!*-subclass responsibility!*-unclassified!public! !
!Container categoriesFor: #inventory2ndPersonWithPrefix:suffix:!*-unclassified!public! !
!Container categoriesFor: #inventory3dPersonWithPrefix:suffix:!*-unclassified!public! !
!Container categoriesFor: #inventoryable!accessing!public! !
!Container categoriesFor: #inventoryable:!accessing!public! !
!Container categoriesFor: #inventoryStringWithPrefix:suffix:!*-unclassified!public! !
!Container categoriesFor: #inventoryWithPrefix:suffix:!*-unclassified!public! !
!Container categoriesFor: #remove:!*-unclassified!public! !

